var combine = require( '../' )
  , fs = require( 'fs' );

// Helper functions
var helper = {
  // Test if obj is a true function
  testFunction: function( test, obj, label ) {
    // The object reports itself as a function
    test( typeof obj, 'function', label +' reports as a function.' );
    // This ensures the repo is actually a derivative of the Function [[Class]]
    test( toString.call( obj ), '[object Function]', label +' [[Class]] is of type function.' );
  },
  // Test code and handle exception thrown 
  testException: function( test, fun, label ) {
    try {
      fun();
      test( false, label );
    }
    catch (ex) {
      test( true, label );
    }
  }
};

exports.partials = function( test ) {
  test.expect(2);

  // Simple single replace with same key name
  var tmpl = combine('{{test}} {%partial test%}', { test: 'hello world' });
  tmpl.partials.add('test', '{{name}}', {
    name: 'lol'
  });
  test.equals( tmpl.render(), 'hello world lol', 'Simple single replace with same key name' );

  // Testing partials with filters
  var tmpl = combine('{{test}} {%partial test%}', { test: 'hello world' });
  tmpl.partials.add('test', '{{name}}', {
    name: 'lol'
  });
  test.equals( tmpl.render(), 'hello world lol', 'Simple single replace with same key name' );

  test.done();
};
